	import javax.swing.*;
import javax.swing.border.EtchedBorder;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.math.BigInteger;
import java.util.Random;

/**
 * @author zippi
 *
 */
public class RSA extends JFrame{

	  /**
	 * 
	 */
	private static final long serialVersionUID = 2360272259025121154L;
	
	private JTextField tp,tn, tq, te, tPhin, td;
	  private JTextArea tnachricht,tnachrichtnum,tempfangen,tempfangennum, tencoded;
	  private JPanel peingabe, perklaer, pdemo, pdemobuttons, pdemocontent;
	  private JLabel lerk;

	  public RSA()
	  {
		super("RSA-Algorithmus");
	    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	    Container cp = getContentPane(); 
	    cp.setLayout(null);
    
	    peingabe = new JPanel(new GridLayout(6,3));
	    peingabe.setBorder(new EtchedBorder());
	    peingabe.setBounds(5,5,530,140);
	    cp.add (peingabe);
	    perklaer = new JPanel(new FlowLayout(FlowLayout.LEFT,3,5));
	    perklaer.setBorder(new EtchedBorder());
	    perklaer.setBounds(540,5,350,615);
	    cp.add (perklaer);
	    pdemo = new JPanel(new BorderLayout(4,3));
	    pdemo.setBorder(new EtchedBorder());
	    pdemo.setBounds(5,160,530,460);
	    cp.add (pdemo);
	    pdemocontent = new JPanel(new GridLayout(2,3,5,5));
	    pdemobuttons = new JPanel(new GridLayout(2,3,5,5));
	    pdemo.add(pdemobuttons, BorderLayout.NORTH);
	    pdemo.add(pdemocontent);
	    
	    
	    
	    
	    JButton pqbutton = new JButton("p,q Berechnen");	
	    JButton keybutton = new JButton("Schlssel Berechnen");
	    JButton encodebutton = new JButton("enkoden");
	    JButton encryptbutton = new JButton("encrypten");
	    JButton decodebutton = new JButton("decrypen, dekoden");
	    
	    keybutton.addActionListener(new ActionListener(){		// schlssel berechnen
    		public void actionPerformed(ActionEvent e){
    			int keyPhin;
				keyPhin  = ((Integer.parseInt(tp.getText())-1)*(Integer.parseInt(tq.getText())-1));  
    			
    			tn.setText(""+ (Integer.parseInt(tp.getText())*Integer.parseInt(tq.getText())));
    			tPhin.setText(""+ keyPhin);
    			te.setText(""+ findeE(Integer.parseInt(tp.getText()),Integer.parseInt(tq.getText()),keyPhin));
    			td.setText(""+ Math.round( finded(Integer.parseInt(te.getText()),keyPhin)));
    			lerk.setText("<html>Nun berechnen wir n = p*q und \u03c6n = (p-1) * (q-1)<br><br>" +
    					"Zudem whlen wir eine beliebige Zahl e fr die gelten <br>" +
    					"muss das sie relativ Prim zu \u03c6n ist.<br><br>" +
    					"Mit Hilfe des erweiterten euklidischen Algorithmus <br>" +
    					"berechnen wir d <br><br>" +
    					"Nchster Schritt: Text enkoden");
    		}
	    });
	    pqbutton.addActionListener(new ActionListener(){		// p und q berechnen
	    	public void actionPerformed(ActionEvent e){
	    		tp.setText(new BigInteger(9 + 1, 20, new Random()).toString());
	    		tq.setText(new BigInteger(9 - 1, 20, new Random()).toString());
    			
	    		lerk.setText("<html> Es werden die 2 Primzahlen p und q berechnet<br><br>" +
    					"Nchster Schritt: Schlssel berechnen");

	    	}
	    });
	    
	    encodebutton.addActionListener(new ActionListener(){	// Text in Zahlen umwandeln
	    	public void actionPerformed(ActionEvent e){
	    		tnachrichtnum.setText(new BigInteger(tnachricht.getText().getBytes()).toString());

	    		lerk.setText("<html> Der Text wurde ber die BigInteger.toString methode <br>" +
	    				"in eine Zeichenkette umgewandelt<br><br>" +
	    				"Nchster Schritt: encrypten");
}
	    });

	    decodebutton.addActionListener(new ActionListener(){	// Verschlsselte Nachricht entschlsseln und dann Zahlen in Text umwandeln
	    	public void actionPerformed(ActionEvent e){
	    		tempfangennum.setText(decrypt(new BigInteger(tencoded.getText()), new BigInteger(td.getText()),	new BigInteger(tn.getText())).toString());
	    		tempfangen.setText(new String(new BigInteger(tempfangennum.getText()).toByteArray()));
	    		
	    		lerk.setText("<html> Es wird die codierte Nachricht <br>" +
	    				"mit dem Private Key entschlsselt<br>" +
	    				"und mit der BigInteger.toByteArray Methode <br>" +
	    				"wieder in einen Text umgewandelt");

	    	}
	    });
	    
	    encryptbutton.addActionListener(new ActionListener(){	// Zahlenwerte mit dem public key verschlsseln
	    	public void actionPerformed(ActionEvent e){
	    		tencoded.setText(encrypt(new BigInteger(tnachrichtnum.getText()), new BigInteger(te.getText()), new BigInteger(tn.getText())).toString());
	    		lerk.setText("<html> Die Zahlenwerte werden in Blcke mit der <br>" +
	    				"gre n-1 aufgeteilt und ber berechnet<br><br>" +
				"Nchster Schritt: decrypten");

	    	}
	    });
	    

	    
	    //eingabefelder fr Primzahlen, und die Schlssel
	    peingabe.add(new JLabel("1. Primzahl p:"));
	    peingabe.add(tp =new JTextField(2));
	    peingabe.add(pqbutton);
	    peingabe.add(new JLabel("2. Primzahl q:"));
	    peingabe.add(tq =new JTextField(2));
	    peingabe.add(new JLabel(""));
	    peingabe.add(new JLabel("n = p * q"));
	    peingabe.add(tn =new JTextField(8));
	    peingabe.add(keybutton);
	    peingabe.add(new JLabel("\u03c6n = (p-1) * (q-1)"));
	    peingabe.add(tPhin =new JTextField(8));
	    peingabe.add(new JLabel(""));
	    peingabe.add(new JLabel("e"));
	    peingabe.add(te =new JTextField(8));
	    peingabe.add(new JLabel(""));

	    peingabe.add(new JLabel("d"));
	    peingabe.add(td =new JTextField(8));
	    peingabe.add(new JLabel(""));
	    
	    // erklrung auf der rechten Seite
	    perklaer.add(lerk= new JLabel("<html>RSA-Demo by Wassilios Argiridis und Martin Zipzer<br><br>" +
	    		"1.Schritt <br>" +
	    		"Bitte 2 gltige Primzahlen in die Felder p und q eintragen<br>" +
	    		"oder ber den Button berechnen lassen.<br><br>" +
	    		"Nchster Schritt: Schlsselemente berechnen"));
	    

	    // Demo encryption und Decryption
	    pdemocontent.add(tnachricht =new JTextArea("Es gibt 10 Gruppen von Menschen, die einen kennen das Binrsystem, die anderen nicht.",2,2));
	    pdemocontent.add(new JLabel(""));
	    pdemocontent.add(tempfangen=new JTextArea("",2,2));
	    pdemocontent.add(tnachrichtnum =new JTextArea("",2,2));
	    pdemocontent.add(tencoded =new JTextArea("",2,2));
	    pdemocontent.add(tempfangennum =new JTextArea("",2,2));
	    tnachricht.setLineWrap(true);
	    tnachricht.setBorder(new EtchedBorder());
	    tnachricht.setWrapStyleWord(true);
	    tempfangen.setLineWrap(true);
	    tempfangen.setEditable(false);
	    tempfangen.setBackground(Color.LIGHT_GRAY);
	    tempfangen.setBorder(new EtchedBorder());
	    tempfangen.setWrapStyleWord(true);
	    tnachrichtnum.setLineWrap(true);	    
	    tnachrichtnum.setBorder(new EtchedBorder());
	    tnachrichtnum.setWrapStyleWord(true);
	    tencoded.setLineWrap(true);
	    tencoded.setBorder(new EtchedBorder());
	    tencoded.setWrapStyleWord(true);
	    tempfangennum.setLineWrap(true);
	    tempfangennum.setBorder(new EtchedBorder());
	    tempfangennum.setEditable(false);	    
	    tempfangennum.setBackground(Color.LIGHT_GRAY);
	    tempfangennum.setWrapStyleWord(true);
	    
	    pdemobuttons.add(encodebutton);
	    pdemobuttons.add(encryptbutton);
	    pdemobuttons.add(decodebutton);
	    pdemobuttons.add(new JLabel("Original Text"));
	    pdemobuttons.add(new JLabel("Encodierter Text"));
	    pdemobuttons.add(new JLabel("Empfangener Text"));
	    
	  };	  
	  

	  public static int findeE(int internp, int internq, int internphi){
		  int erg;
		  int ggt =0;
		  erg = 2;
		  while (ggt != 1){
			  erg++;
			  ggt = findeggt(erg, internphi);
		  }
		  
		  return erg;
	  }
	  
	  public static int findeggt(int m, int n){
		  if (m == 0) {
			      return n;
			   }
			   if (n == 0) {
			      return m;
			   }
			   if (m < 0) {
			      return findeggt(-m,n);
			   }
			   if (n < 0) {
			      return findeggt(m,-n);
			   }
			   if (m > n) {
			      return euklid(n,m);
			   }
			   return euklid(m,n);
	  }
	  
	  public static int euklid(int m, int n){
		   int a = m%n;
		   while (a != 0) {
		      m = n;
		      n = a;
		      a = m%n;
		   }
		   return n;
	  }
	  
	  public static double finded(int internE,int internPHI) {
		  double u1, u2, u3,  inverse, vv;
		  double q,t1,t2,t3,v1,v2,v3;
		  u1 = 1;
		  u2 = 0;
		  u3 = internPHI;
		  v1 = 0;
		  v2 = 1;
		  v3 = internE;

		  while (v3 != 0) {
		       q = Math.floor(u3/v3);
		       t1 = u1 - q * v1;
		       t2 = u2 - q * v2;
		       t3 = u3 - q * v3;

		       u1 = v1;
		       u2 = v2;
		       u3 = v3;

		       v1 = t1;
		       v2 = t2;
		       v3 = t3;
		  }

		  vv = u2;

		  if (vv < 0) {
		            inverse = vv + internPHI;
		  } else {
		       inverse = vv;
		  }
		  return inverse;
		  }
	  
	  


	  public static BigInteger encrypt(BigInteger m, BigInteger e, BigInteger n) {
		BigInteger c, bitmask;
		c = new BigInteger("0");
		int i = 0;
		bitmask = (new BigInteger("2")).pow(n.bitLength()-1).subtract(new BigInteger("1"));
		while (m.compareTo(bitmask) == 1) {
			c = m.and(bitmask).modPow(e,n).shiftLeft(i*n.bitLength()).or(c);
			m = m.shiftRight(n.bitLength()-1);
			i = i+1;
		}
		c = m.modPow(e,n).shiftLeft(i*n.bitLength()).or(c);
		return c;
	}
	  


	public static BigInteger decrypt(BigInteger c, BigInteger d, BigInteger n) {
		BigInteger m, bitmask;
		m = new BigInteger("0");
		int i = 0;
		bitmask = (new BigInteger("2")).pow(n.bitLength()).subtract(new BigInteger("1"));
		while (c.compareTo(bitmask) == 1) {
			m = c.and(bitmask).modPow(d,n).shiftLeft(i*(n.bitLength()-1)).or(m);
			c = c.shiftRight(n.bitLength());
			i = i+1;
		}
		m = c.modPow(d,n).shiftLeft(i*(n.bitLength()-1)).or(m);
		
	  	return m;
	}

	  
	public static void main(String[] args) {
		// TODO Auto-generated method stub
	    RSA frame = new RSA();
	    frame.setLocation(100, 100);
	    frame.setSize(900, 650);
	    frame.setVisible(true);

	}

}
